unit DReport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBClient, MConnect, SConnect, DocServer_TLB;

type
  TDMReport = class(TDataModule)
    scReport: TSocketConnection;
    cdsInOutRes: TClientDataSet;
    dsInOut: TDataSource;
    procedure scReportAfterConnect(Sender: TObject);
    procedure scReportBeforeDisconnect(Sender: TObject);
  private
    FServer: IrdmReportDisp;
    { Private declarations }
  public
    procedure ShowInOutReport(FromDate, ToDate: TDateTime); overload;
    procedure ShowInOutReport; overload;
    procedure RefreshInOut(FromDate, ToDate: TDateTime);
    { Public declarations }
  end;

var
  DMReport: TDMReport;

implementation

uses FInOut;

{$R *.DFM}

{ TDMReport }

procedure TDMReport.RefreshInOut(FromDate, ToDate: TDateTime);
begin
  scReport.Connected := True;
  with cdsInOutRes do
  begin
    Active := False;
    Data := FServer.InOutData(int(FromDate), int(ToDate));
    Active := True;
  end;
end;

procedure TDMReport.ShowInOutReport(FromDate, ToDate: TDateTime);
begin
  Application.CreateForm(TFormInOut, FormInOut);
  try
    with FormInOut do
    begin
      dtpFrom.Date := int(FromDate);
      dtpTo.Date := int(ToDate);
      ShowModal;
    end;
    cdsInOutRes.Active := False;
  finally
    FormInOut.Release;
  end;
end;

procedure TDMReport.scReportAfterConnect(Sender: TObject);
begin
  FServer := IrdmReportDisp(scReport.GetServer)
end;

procedure TDMReport.scReportBeforeDisconnect(Sender: TObject);
begin
  FServer := nil;
end;

procedure TDMReport.ShowInOutReport;
begin
  Application.CreateForm(TFormInOut, FormInOut);
  try
    with FormInOut do
    begin
      dtpFrom.Date := Date - 7;
      dtpTo.Date := Date;
      ShowModal;
    end;
    cdsInOutRes.Active := False;
  finally
    FormInOut.Release;
  end;
end;

end.
