unit FClient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, DBCtrls, Grids, DBGrids, ExtCtrls;

type
  TFormClients = class(TForm)
    Panel1: TPanel;
    DBGrid: TDBGrid;
    DBNav: TDBNavigator;
    bbCancel: TBitBtn;
    bbOK: TBitBtn;
    procedure bbOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FClientID: Integer;
    procedure SetClientID(const Value: Integer);
    function GetClientID: Integer;
    { Private declarations }
  public
    property ClientID: Integer read GetClientID write SetClientID;
    { Public declarations }
  end;

var
  FormClients: TFormClients;

implementation

uses DCommon, DB;

{$R *.DFM}

procedure TFormClients.bbOKClick(Sender: TObject);
var
  Err: Integer;
begin
  with DMCommon.cdsClient do
  begin
    if State in [dsEdit, dsInsert] then
      Post;
    FClientID := FieldByName('CLIENT_ID').AsInteger;
    Err := 0;
    if ChangeCount > 0 then
      Err := ApplyUpdates(-1);
    if Err = 0 then
      ModalResult := mrOK;
  end;
end;

procedure TFormClients.FormShow(Sender: TObject);
begin
  DMCommon.cdsClient.Active := True;
end;

procedure TFormClients.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DMCommon.cdsClient.Active := False;
  if ModalResult <> mrOK then
    FClientID := 0;
end;

procedure TFormClients.SetClientID(const Value: Integer);
begin
  if FClientID = Value then Exit;
  if DMCommon.cdsClient.Locate('CLIENT_ID',Value,[]) then
    FClientID := Value;
end;

function TFormClients.GetClientID: Integer;
begin
  Result := FClientID;
end;

end.
