unit FDoc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, Grids, DBGrids, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TFormDoc = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    BitBtnFrom: TBitBtn;
    BitBtnTo: TBitBtn;
    dbgBody: TDBGrid;
    DBNavigator1: TDBNavigator;
    Label5: TLabel;
    BitBtnOK: TBitBtn;
    BitBtnCancel: TBitBtn;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    procedure FormShow(Sender: TObject);
    procedure BitBtnFromClick(Sender: TObject);
    procedure BitBtnToClick(Sender: TObject);
    procedure BitBtnOKClick(Sender: TObject);
  private
    procedure GetClientNames;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormDoc: TFormDoc;

implementation

uses DDoc, DB, DCommon;

{$R *.DFM}

{ TFormDoc }

procedure TFormDoc.GetClientNames;
var
  ClientID: Integer;
begin
  with DMDoc do
  begin
    ClientID := cdsTitle.FieldByName('FROM_ID').AsInteger;
    SetSenderName(ClientID);
    ClientID := cdsTitle.FieldByName('TO_ID').AsInteger;
    SetReceiverName(ClientID);
  end;
end;

procedure TFormDoc.FormShow(Sender: TObject);
begin
  GetClientNames;
end;

procedure TFormDoc.BitBtnFromClick(Sender: TObject);
var
  AClientID: Integer;
begin
  AClientID := DMCommon.ShowClients;
  if AClientID = 0 then Exit;
  DMDoc.SetSenderName(AClientID);
end;

procedure TFormDoc.BitBtnToClick(Sender: TObject);
var
  AClientID: Integer;
begin
  AClientID := DMCommon.ShowClients;
  if AClientID = 0 then Exit;
  DMDoc.SetReceiverName(AClientID);
end;

procedure TFormDoc.BitBtnOKClick(Sender: TObject);
begin
  if DMDoc.ApplyDoc then
    ModalResult := mrOK;
end;

end.
