unit FMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, Grids, DBGrids, ExtCtrls, ComCtrls, StdCtrls, Buttons;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    DBGrid: TDBGrid;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    bbRefresh: TBitBtn;
    dtpFrom: TDateTimePicker;
    dtpTo: TDateTimePicker;
    bbClients: TBitBtn;
    BitBtnAdd: TBitBtn;
    BitBtnDel: TBitBtn;
    BitBtnEdit: TBitBtn;
    BitBtnReport: TBitBtn;
    btnClose: TButton;
    procedure bbRefreshClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtnReportClick(Sender: TObject);
    procedure DBGridTitleClick(Column: TColumn);
    procedure btnCloseClick(Sender: TObject);
    procedure BitBtnAddClick(Sender: TObject);
    procedure BitBtnEditClick(Sender: TObject);
    procedure BitBtnDelClick(Sender: TObject);
  private
    procedure ShowBoldTitle;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses DCommon, DReport, DB, DbClient;

{$R *.DFM}

procedure TFormMain.bbRefreshClick(Sender: TObject);
begin
  with DBGrid.DataSource.Dataset as TClientDataSet do
  begin
    Active := False;
    with params do
    begin
      paramByName('FromDate').asDate :=
        int(dtpFrom.Date);
      paramByName('ToDate').asDate :=
        int(dtpTo.Date);
    end;
    Active := True;
  end;
  ShowBoldTitle;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  dtpFrom.Date := Date - 7;
  dtpTo.Date := Date;
  bbRefresh.Click;
end;

procedure TFormMain.BitBtnReportClick(Sender: TObject);
begin
  DMReport.ShowInOutReport(dtpFrom.Date, dtpTo.Date);
end;

procedure TFormMain.DBGridTitleClick(Column: TColumn);
var
  ColumnNo,i: Integer;
  DispName: string;
begin
  ColumnNo := 1;
  DispName := Column.Field.DisplayName;
  try
    with DBGrid do
      for i := 0 to Columns.Count - 1 do
        if Columns[i].Field.DisplayName = DispName then
          if Columns[i].Field.FieldKind <> fkData then Exit
          else
          begin
            ColumnNo := i;
            Break;
          end;

    with DbGrid.DataSource.DataSet as TClientDataSet do
      IndexFieldNames := DBGrid.Columns[ColumnNo].FieldName;

    with DBGrid do
      for i := 0 to Columns.Count - 1 do
        if i = ColumnNo then
          with Columns[i].Title.Font do
            Style := Style + [fsBold]
        else
          with Columns[i].Title.Font do
            Style := Style - [fsBold];
  except
  end;
end;

procedure TFormMain.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.ShowBoldTitle;
var
  i: Integer;
begin
  with DBGrid.DataSource.Dataset as TClientDataSet do
    for i := 0 to DBGrid.Columns.Count - 1 do
      if Pos(DBGrid.Columns[i].FieldName, IndexFieldNames) = 1 then
        with DBGrid.Columns[i].Title.Font do
          Style := Style + [fsBold]
      else
        with DBGrid.Columns[i].Title.Font do
          Style := Style - [fsBold];
end;

procedure TFormMain.BitBtnAddClick(Sender: TObject);
begin
  DMCommon.ActNewDoc.Execute;
  ShowBoldTitle;
end;

procedure TFormMain.BitBtnEditClick(Sender: TObject);
begin
  DMCommon.actEditDoc.Execute;
  ShowBoldTitle;
end;

procedure TFormMain.BitBtnDelClick(Sender: TObject);
begin
  DMCommon.actDelDoc.Execute;
  ShowBoldTitle;
end;

end.
